# WARNING: Please don't edit this file. It was generated by Python/WinRT v3.0.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections
import winrt.windows.networking as windows_networking
import winrt.windows.storage as windows_storage
import winrt.windows.storage.streams as windows_storage_streams

from winrt.windows.security.enterprisedata import DataProtectionStatus, EnforcementLevel, FileProtectionStatus, ProtectedImportExportStatus, ProtectionPolicyAuditAction, ProtectionPolicyEvaluationResult, ProtectionPolicyRequestAccessBehavior

Self = typing.TypeVar('Self')

@typing.final
class BufferProtectUnprotectResult(winrt.system.Object):
    # Windows.Storage.Streams.IBuffer Windows.Security.EnterpriseData.BufferProtectUnprotectResult::get_Buffer()
    @_property
    def buffer(self) -> windows_storage_streams.IBuffer: ...
    # Windows.Security.EnterpriseData.DataProtectionInfo Windows.Security.EnterpriseData.BufferProtectUnprotectResult::get_ProtectionInfo()
    @_property
    def protection_info(self) -> DataProtectionInfo: ...

@typing.final
class DataProtectionInfo(winrt.system.Object):
    # System.String Windows.Security.EnterpriseData.DataProtectionInfo::get_Identity()
    @_property
    def identity(self) -> str: ...
    # Windows.Security.EnterpriseData.DataProtectionStatus Windows.Security.EnterpriseData.DataProtectionInfo::get_Status()
    @_property
    def status(self) -> DataProtectionStatus: ...

@typing.final
class DataProtectionManager_Static(winrt._winrt.IInspectable_Static):
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.DataProtectionInfo> Windows.Security.EnterpriseData.DataProtectionManager::GetProtectionInfoAsync(Windows.Storage.Streams.IBuffer)
    def get_protection_info_async(cls, protected_data: windows_storage_streams.IBuffer, /) -> windows_foundation.IAsyncOperation[DataProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.DataProtectionInfo> Windows.Security.EnterpriseData.DataProtectionManager::GetStreamProtectionInfoAsync(Windows.Storage.Streams.IInputStream)
    def get_stream_protection_info_async(cls, protected_stream: windows_storage_streams.IInputStream, /) -> windows_foundation.IAsyncOperation[DataProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.BufferProtectUnprotectResult> Windows.Security.EnterpriseData.DataProtectionManager::ProtectAsync(Windows.Storage.Streams.IBuffer,System.String)
    def protect_async(cls, data: windows_storage_streams.IBuffer, identity: str, /) -> windows_foundation.IAsyncOperation[BufferProtectUnprotectResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.DataProtectionInfo> Windows.Security.EnterpriseData.DataProtectionManager::ProtectStreamAsync(Windows.Storage.Streams.IInputStream,System.String,Windows.Storage.Streams.IOutputStream)
    def protect_stream_async(cls, unprotected_stream: windows_storage_streams.IInputStream, identity: str, protected_stream: windows_storage_streams.IOutputStream, /) -> windows_foundation.IAsyncOperation[DataProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.BufferProtectUnprotectResult> Windows.Security.EnterpriseData.DataProtectionManager::UnprotectAsync(Windows.Storage.Streams.IBuffer)
    def unprotect_async(cls, data: windows_storage_streams.IBuffer, /) -> windows_foundation.IAsyncOperation[BufferProtectUnprotectResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.DataProtectionInfo> Windows.Security.EnterpriseData.DataProtectionManager::UnprotectStreamAsync(Windows.Storage.Streams.IInputStream,Windows.Storage.Streams.IOutputStream)
    def unprotect_stream_async(cls, protected_stream: windows_storage_streams.IInputStream, unprotected_stream: windows_storage_streams.IOutputStream, /) -> windows_foundation.IAsyncOperation[DataProtectionInfo]: ...

@typing.final
class DataProtectionManager(winrt.system.Object, metaclass=DataProtectionManager_Static):
    pass

@typing.final
class FileProtectionInfo(winrt.system.Object):
    # System.String Windows.Security.EnterpriseData.FileProtectionInfo::get_Identity()
    @_property
    def identity(self) -> str: ...
    # System.Boolean Windows.Security.EnterpriseData.FileProtectionInfo::get_IsRoamable()
    @_property
    def is_roamable(self) -> bool: ...
    # Windows.Security.EnterpriseData.FileProtectionStatus Windows.Security.EnterpriseData.FileProtectionInfo::get_Status()
    @_property
    def status(self) -> FileProtectionStatus: ...
    # System.Boolean Windows.Security.EnterpriseData.FileProtectionInfo::get_IsProtectWhileOpenSupported()
    @_property
    def is_protect_while_open_supported(self) -> bool: ...

@typing.final
class FileProtectionManager_Static(winrt._winrt.IInspectable_Static):
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Security.EnterpriseData.FileProtectionManager::CopyProtectionAsync(Windows.Storage.IStorageItem,Windows.Storage.IStorageItem)
    def copy_protection_async(cls, source: windows_storage.IStorageItem, target: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedFileCreateResult> Windows.Security.EnterpriseData.FileProtectionManager::CreateProtectedAndOpenAsync(Windows.Storage.IStorageFolder,System.String,System.String,Windows.Storage.CreationCollisionOption)
    def create_protected_and_open_async(cls, parent_folder: windows_storage.IStorageFolder, desired_name: str, identity: str, collision_option: windows_storage.CreationCollisionOption, /) -> windows_foundation.IAsyncOperation[ProtectedFileCreateResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionInfo> Windows.Security.EnterpriseData.FileProtectionManager::GetProtectionInfoAsync(Windows.Storage.IStorageItem)
    def get_protection_info_async(cls, source: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[FileProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Security.EnterpriseData.FileProtectionManager::IsContainerAsync(Windows.Storage.IStorageFile)
    def is_container_async(cls, file: windows_storage.IStorageFile, /) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedContainerImportResult> Windows.Security.EnterpriseData.FileProtectionManager::LoadFileFromContainerAsync(Windows.Storage.IStorageFile)
    def load_file_from_container_async(cls, container_file: windows_storage.IStorageFile, /) -> windows_foundation.IAsyncOperation[ProtectedContainerImportResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedContainerImportResult> Windows.Security.EnterpriseData.FileProtectionManager::LoadFileFromContainerAsync(Windows.Storage.IStorageFile,Windows.Storage.IStorageItem,Windows.Storage.NameCollisionOption)
    def load_file_from_container_with_target_and_name_collision_option_async(cls, container_file: windows_storage.IStorageFile, target: windows_storage.IStorageItem, collision_option: windows_storage.NameCollisionOption, /) -> windows_foundation.IAsyncOperation[ProtectedContainerImportResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedContainerImportResult> Windows.Security.EnterpriseData.FileProtectionManager::LoadFileFromContainerAsync(Windows.Storage.IStorageFile,Windows.Storage.IStorageItem)
    def load_file_from_container_with_target_async(cls, container_file: windows_storage.IStorageFile, target: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[ProtectedContainerImportResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionInfo> Windows.Security.EnterpriseData.FileProtectionManager::ProtectAsync(Windows.Storage.IStorageItem,System.String)
    def protect_async(cls, target: windows_storage.IStorageItem, identity: str, /) -> windows_foundation.IAsyncOperation[FileProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedContainerExportResult> Windows.Security.EnterpriseData.FileProtectionManager::SaveFileAsContainerAsync(Windows.Storage.IStorageFile)
    def save_file_as_container_async(cls, protected_file: windows_storage.IStorageFile, /) -> windows_foundation.IAsyncOperation[ProtectedContainerExportResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectedContainerExportResult> Windows.Security.EnterpriseData.FileProtectionManager::SaveFileAsContainerAsync(Windows.Storage.IStorageFile,Windows.Foundation.Collections.IIterable`1<System.String>)
    def save_file_as_container_with_sharing_async(cls, protected_file: windows_storage.IStorageFile, shared_with_identities: typing.Iterable[str], /) -> windows_foundation.IAsyncOperation[ProtectedContainerExportResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionInfo> Windows.Security.EnterpriseData.FileProtectionManager::UnprotectAsync(Windows.Storage.IStorageItem)
    def unprotect_async(cls, target: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[FileProtectionInfo]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionInfo> Windows.Security.EnterpriseData.FileProtectionManager::UnprotectAsync(Windows.Storage.IStorageItem,Windows.Security.EnterpriseData.FileUnprotectOptions)
    def unprotect_with_options_async(cls, target: windows_storage.IStorageItem, options: FileUnprotectOptions, /) -> windows_foundation.IAsyncOperation[FileProtectionInfo]: ...

@typing.final
class FileProtectionManager(winrt.system.Object, metaclass=FileProtectionManager_Static):
    pass

@typing.final
class FileRevocationManager_Static(winrt._winrt.IInspectable_Static):
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Security.EnterpriseData.FileRevocationManager::CopyProtectionAsync(Windows.Storage.IStorageItem,Windows.Storage.IStorageItem)
    # @deprecated("FileRevocationManager might be unavailable after Windows 10. Instead, use FileProtectionManager.")
    def copy_protection_async(cls, source_storage_item: windows_storage.IStorageItem, target_storage_item: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionStatus> Windows.Security.EnterpriseData.FileRevocationManager::GetStatusAsync(Windows.Storage.IStorageItem)
    # @deprecated("FileRevocationManager might be unavailable after Windows 10. Instead, use FileProtectionManager.")
    def get_status_async(cls, storage_item: windows_storage.IStorageItem, /) -> windows_foundation.IAsyncOperation[FileProtectionStatus]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.FileProtectionStatus> Windows.Security.EnterpriseData.FileRevocationManager::ProtectAsync(Windows.Storage.IStorageItem,System.String)
    # @deprecated("FileRevocationManager might be unavailable after Windows 10. Instead, use FileProtectionManager.")
    def protect_async(cls, storage_item: windows_storage.IStorageItem, enterprise_identity: str, /) -> windows_foundation.IAsyncOperation[FileProtectionStatus]: ...
    # System.Void Windows.Security.EnterpriseData.FileRevocationManager::Revoke(System.String)
    # @deprecated("FileRevocationManager might be unavailable after Windows 10. Instead, use FileProtectionManager.")
    def revoke(cls, enterprise_identity: str, /) -> None: ...

@typing.final
class FileRevocationManager(winrt.system.Object, metaclass=FileRevocationManager_Static):
    pass

@typing.final
class FileUnprotectOptions(winrt.system.Object):
    def __new__(cls: typing.Type[Self], audit: bool) -> Self: ...
    # System.Boolean Windows.Security.EnterpriseData.FileUnprotectOptions::get_Audit()
    @_property
    def audit(self) -> bool: ...
    # System.Void Windows.Security.EnterpriseData.FileUnprotectOptions::put_Audit(System.Boolean)
    @audit.setter
    def audit(self, value: bool) -> None: ...

@typing.final
class ProtectedAccessResumedEventArgs(winrt.system.Object):
    # Windows.Foundation.Collections.IVectorView`1<System.String> Windows.Security.EnterpriseData.ProtectedAccessResumedEventArgs::get_Identities()
    @_property
    def identities(self) -> typing.Sequence[str]: ...

@typing.final
class ProtectedAccessSuspendingEventArgs(winrt.system.Object):
    # Windows.Foundation.Deferral Windows.Security.EnterpriseData.ProtectedAccessSuspendingEventArgs::GetDeferral()
    def get_deferral(self) -> windows_foundation.Deferral: ...
    # Windows.Foundation.DateTime Windows.Security.EnterpriseData.ProtectedAccessSuspendingEventArgs::get_Deadline()
    @_property
    def deadline(self) -> datetime.datetime: ...
    # Windows.Foundation.Collections.IVectorView`1<System.String> Windows.Security.EnterpriseData.ProtectedAccessSuspendingEventArgs::get_Identities()
    @_property
    def identities(self) -> typing.Sequence[str]: ...

@typing.final
class ProtectedContainerExportResult(winrt.system.Object):
    # Windows.Storage.StorageFile Windows.Security.EnterpriseData.ProtectedContainerExportResult::get_File()
    @_property
    def file(self) -> windows_storage.StorageFile: ...
    # Windows.Security.EnterpriseData.ProtectedImportExportStatus Windows.Security.EnterpriseData.ProtectedContainerExportResult::get_Status()
    @_property
    def status(self) -> ProtectedImportExportStatus: ...

@typing.final
class ProtectedContainerImportResult(winrt.system.Object):
    # Windows.Storage.StorageFile Windows.Security.EnterpriseData.ProtectedContainerImportResult::get_File()
    @_property
    def file(self) -> windows_storage.StorageFile: ...
    # Windows.Security.EnterpriseData.ProtectedImportExportStatus Windows.Security.EnterpriseData.ProtectedContainerImportResult::get_Status()
    @_property
    def status(self) -> ProtectedImportExportStatus: ...

@typing.final
class ProtectedContentRevokedEventArgs(winrt.system.Object):
    # Windows.Foundation.Collections.IVectorView`1<System.String> Windows.Security.EnterpriseData.ProtectedContentRevokedEventArgs::get_Identities()
    @_property
    def identities(self) -> typing.Sequence[str]: ...

@typing.final
class ProtectedFileCreateResult(winrt.system.Object):
    # Windows.Storage.StorageFile Windows.Security.EnterpriseData.ProtectedFileCreateResult::get_File()
    @_property
    def file(self) -> windows_storage.StorageFile: ...
    # Windows.Security.EnterpriseData.FileProtectionInfo Windows.Security.EnterpriseData.ProtectedFileCreateResult::get_ProtectionInfo()
    @_property
    def protection_info(self) -> FileProtectionInfo: ...
    # Windows.Storage.Streams.IRandomAccessStream Windows.Security.EnterpriseData.ProtectedFileCreateResult::get_Stream()
    @_property
    def stream(self) -> windows_storage_streams.IRandomAccessStream: ...

@typing.final
class ProtectionPolicyAuditInfo(winrt.system.Object):
    @typing.overload
    def __new__(cls: typing.Type[Self], action: ProtectionPolicyAuditAction, data_description: str, source_description: str, target_description: str) -> Self: ...
    @typing.overload
    def __new__(cls: typing.Type[Self], action: ProtectionPolicyAuditAction, data_description: str) -> Self: ...
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::get_TargetDescription()
    @_property
    def target_description(self) -> str: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::put_TargetDescription(System.String)
    @target_description.setter
    def target_description(self, value: str) -> None: ...
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::get_SourceDescription()
    @_property
    def source_description(self) -> str: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::put_SourceDescription(System.String)
    @source_description.setter
    def source_description(self, value: str) -> None: ...
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::get_DataDescription()
    @_property
    def data_description(self) -> str: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::put_DataDescription(System.String)
    @data_description.setter
    def data_description(self, value: str) -> None: ...
    # Windows.Security.EnterpriseData.ProtectionPolicyAuditAction Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::get_Action()
    @_property
    def action(self) -> ProtectionPolicyAuditAction: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo::put_Action(Windows.Security.EnterpriseData.ProtectionPolicyAuditAction)
    @action.setter
    def action(self, value: ProtectionPolicyAuditAction) -> None: ...

@typing.final
class ProtectionPolicyManager_Static(winrt._winrt.IInspectable_Static):
    # Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult Windows.Security.EnterpriseData.ProtectionPolicyManager::CheckAccess(System.String,System.String)
    def check_access(cls, source_identity: str, target_identity: str, /) -> ProtectionPolicyEvaluationResult: ...
    # Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult Windows.Security.EnterpriseData.ProtectionPolicyManager::CheckAccessForApp(System.String,System.String)
    def check_access_for_app(cls, source_identity: str, app_package_family_name: str, /) -> ProtectionPolicyEvaluationResult: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::ClearProcessUIPolicy()
    def clear_process_ui_policy(cls) -> None: ...
    # Windows.Security.EnterpriseData.ThreadNetworkContext Windows.Security.EnterpriseData.ProtectionPolicyManager::CreateCurrentThreadNetworkContext(System.String)
    def create_current_thread_network_context(cls, identity: str, /) -> ThreadNetworkContext: ...
    # Windows.Security.EnterpriseData.EnforcementLevel Windows.Security.EnterpriseData.ProtectionPolicyManager::GetEnforcementLevel(System.String)
    def get_enforcement_level(cls, identity: str, /) -> EnforcementLevel: ...
    # Windows.Security.EnterpriseData.ProtectionPolicyManager Windows.Security.EnterpriseData.ProtectionPolicyManager::GetForCurrentView()
    def get_for_current_view(cls) -> ProtectionPolicyManager: ...
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyManager::GetPrimaryManagedIdentityForIdentity(System.String)
    def get_primary_managed_identity_for_identity(cls, identity: str, /) -> str: ...
    # Windows.Foundation.IAsyncOperation`1<System.String> Windows.Security.EnterpriseData.ProtectionPolicyManager::GetPrimaryManagedIdentityForNetworkEndpointAsync(Windows.Networking.HostName)
    def get_primary_managed_identity_for_network_endpoint_async(cls, endpoint_host: windows_networking.HostName, /) -> windows_foundation.IAsyncOperation[str]: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::HasContentBeenRevokedSince(System.String,Windows.Foundation.DateTime)
    def has_content_been_revoked_since(cls, identity: str, since: datetime.datetime, /) -> bool: ...
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Security.EnterpriseData.ProtectionPolicyManager::IsFileProtectionRequiredAsync(Windows.Storage.IStorageItem,System.String)
    def is_file_protection_required_async(cls, target: windows_storage.IStorageItem, identity: str, /) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Security.EnterpriseData.ProtectionPolicyManager::IsFileProtectionRequiredForNewFileAsync(Windows.Storage.IStorageFolder,System.String,System.String)
    def is_file_protection_required_for_new_file_async(cls, parent_folder: windows_storage.IStorageFolder, identity: str, desired_name: str, /) -> windows_foundation.IAsyncOperation[bool]: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::IsIdentityManaged(System.String)
    def is_identity_managed(cls, identity: str, /) -> bool: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::IsProtectionUnderLockRequired(System.String)
    def is_protection_under_lock_required(cls, identity: str, /) -> bool: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::IsRoamableProtectionEnabled(System.String)
    def is_roamable_protection_enabled(cls, identity: str, /) -> bool: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::IsUserDecryptionAllowed(System.String)
    def is_user_decryption_allowed(cls, identity: str, /) -> bool: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::LogAuditEvent(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo)
    def log_audit_event(cls, source_identity: str, target_identity: str, audit_info: ProtectionPolicyAuditInfo, /) -> None: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessAsync(System.String,System.String)
    def request_access_async(cls, source_identity: str, target_identity: str, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessForAppAsync(System.String,System.String)
    def request_access_for_app_async(cls, source_identity: str, app_package_family_name: str, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessForAppAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo)
    def request_access_for_app_with_auditing_info_async(cls, source_identity: str, app_package_family_name: str, audit_info: ProtectionPolicyAuditInfo, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessForAppAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String,Windows.Security.EnterpriseData.ProtectionPolicyRequestAccessBehavior)
    def request_access_for_app_with_behavior_async(cls, source_identity: str, app_package_family_name: str, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, behavior: ProtectionPolicyRequestAccessBehavior, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessForAppAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String)
    def request_access_for_app_with_message_async(cls, source_identity: str, app_package_family_name: str, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessToFilesForAppAsync(Windows.Foundation.Collections.IIterable`1<Windows.Storage.IStorageItem>,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo)
    def request_access_to_files_for_app_async(cls, source_item_list: typing.Iterable[windows_storage.IStorageItem], app_package_family_name: str, audit_info: ProtectionPolicyAuditInfo, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessToFilesForAppAsync(Windows.Foundation.Collections.IIterable`1<Windows.Storage.IStorageItem>,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String,Windows.Security.EnterpriseData.ProtectionPolicyRequestAccessBehavior)
    def request_access_to_files_for_app_with_message_and_behavior_async(cls, source_item_list: typing.Iterable[windows_storage.IStorageItem], app_package_family_name: str, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, behavior: ProtectionPolicyRequestAccessBehavior, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessToFilesForProcessAsync(Windows.Foundation.Collections.IIterable`1<Windows.Storage.IStorageItem>,System.UInt32,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo)
    def request_access_to_files_for_process_async(cls, source_item_list: typing.Iterable[windows_storage.IStorageItem], process_id: winrt.system.UInt32, audit_info: ProtectionPolicyAuditInfo, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessToFilesForProcessAsync(Windows.Foundation.Collections.IIterable`1<Windows.Storage.IStorageItem>,System.UInt32,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String,Windows.Security.EnterpriseData.ProtectionPolicyRequestAccessBehavior)
    def request_access_to_files_for_process_with_message_and_behavior_async(cls, source_item_list: typing.Iterable[windows_storage.IStorageItem], process_id: winrt.system.UInt32, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, behavior: ProtectionPolicyRequestAccessBehavior, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo)
    def request_access_with_auditing_info_async(cls, source_identity: str, target_identity: str, audit_info: ProtectionPolicyAuditInfo, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String,Windows.Security.EnterpriseData.ProtectionPolicyRequestAccessBehavior)
    def request_access_with_behavior_async(cls, source_identity: str, target_identity: str, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, behavior: ProtectionPolicyRequestAccessBehavior, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Security.EnterpriseData.ProtectionPolicyEvaluationResult> Windows.Security.EnterpriseData.ProtectionPolicyManager::RequestAccessAsync(System.String,System.String,Windows.Security.EnterpriseData.ProtectionPolicyAuditInfo,System.String)
    def request_access_with_message_async(cls, source_identity: str, target_identity: str, audit_info: ProtectionPolicyAuditInfo, message_from_app: str, /) -> windows_foundation.IAsyncOperation[ProtectionPolicyEvaluationResult]: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::RevokeContent(System.String)
    def revoke_content(cls, identity: str, /) -> None: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::TryApplyProcessUIPolicy(System.String)
    def try_apply_process_ui_policy(cls, identity: str, /) -> bool: ...
    # Windows.Foundation.EventRegistrationToken Windows.Security.EnterpriseData.ProtectionPolicyManager::add_PolicyChanged(Windows.Foundation.EventHandler`1<System.Object>)
    def add_policy_changed(cls, handler: windows_foundation.EventHandler[winrt.system.Object], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::remove_PolicyChanged(Windows.Foundation.EventRegistrationToken)
    def remove_policy_changed(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Security.EnterpriseData.ProtectionPolicyManager::add_ProtectedAccessResumed(Windows.Foundation.EventHandler`1<Windows.Security.EnterpriseData.ProtectedAccessResumedEventArgs>)
    def add_protected_access_resumed(cls, handler: windows_foundation.EventHandler[ProtectedAccessResumedEventArgs], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::remove_ProtectedAccessResumed(Windows.Foundation.EventRegistrationToken)
    def remove_protected_access_resumed(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Security.EnterpriseData.ProtectionPolicyManager::add_ProtectedAccessSuspending(Windows.Foundation.EventHandler`1<Windows.Security.EnterpriseData.ProtectedAccessSuspendingEventArgs>)
    def add_protected_access_suspending(cls, handler: windows_foundation.EventHandler[ProtectedAccessSuspendingEventArgs], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::remove_ProtectedAccessSuspending(Windows.Foundation.EventRegistrationToken)
    def remove_protected_access_suspending(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Security.EnterpriseData.ProtectionPolicyManager::add_ProtectedContentRevoked(Windows.Foundation.EventHandler`1<Windows.Security.EnterpriseData.ProtectedContentRevokedEventArgs>)
    def add_protected_content_revoked(cls, handler: windows_foundation.EventHandler[ProtectedContentRevokedEventArgs], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::remove_ProtectedContentRevoked(Windows.Foundation.EventRegistrationToken)
    def remove_protected_content_revoked(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::get_IsProtectionEnabled()
    @_property
    def is_protection_enabled(cls) -> bool: ...
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyManager::get_PrimaryManagedIdentity()
    @_property
    def primary_managed_identity(cls) -> str: ...

@typing.final
class ProtectionPolicyManager(winrt.system.Object, metaclass=ProtectionPolicyManager_Static):
    # System.String Windows.Security.EnterpriseData.ProtectionPolicyManager::get_Identity()
    @_property
    def identity(self) -> str: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::put_Identity(System.String)
    @identity.setter
    def identity(self, value: str) -> None: ...
    # System.Boolean Windows.Security.EnterpriseData.ProtectionPolicyManager::get_ShowEnterpriseIndicator()
    @_property
    def show_enterprise_indicator(self) -> bool: ...
    # System.Void Windows.Security.EnterpriseData.ProtectionPolicyManager::put_ShowEnterpriseIndicator(System.Boolean)
    @show_enterprise_indicator.setter
    def show_enterprise_indicator(self, value: bool) -> None: ...

@typing.final
class ThreadNetworkContext(winrt.system.Object, windows_foundation.IClosable):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, exc_type: typing.Optional[typing.Type[BaseException]], exc_value: typing.Optional[BaseException], traceback: typing.Optional[types.TracebackType]) -> None: ...
    # System.Void Windows.Security.EnterpriseData.ThreadNetworkContext::Close()
    def close(self) -> None: ...

